
#include "Servo8Bit.h"
#define trigPin 0
#define echoPin 3

int motorPinL = 1;
int motorPinR = 2;
Servo8Bit motorL, motorR;

void setup() {

  pinMode(trigPin, OUTPUT);
  pinMode(echoPin, INPUT);
  motorL.attach(motorPinL);
  motorR.attach(motorPinR);
  digitalWrite(0, HIGH);
}

void loop() {

  // read distance from the HC-SR04
  int distance = getDistance();

  if (distance < 5) {
    // stop
//    moveMotors(90, 90);  
    avoidObstacle();
  
  } else if (distance < 90) {
    // move forward at a speed proportional to the distance
    moveMotors(90+distance, 90+distance);
  } else {
    // go forward full tilt!
    moveMotors(180, 180);
  }
  
}

void avoidObstacle() {
  // stop and wait a beat
  moveMotors(90,90);
  delay(500); 
  
  // move backwards for a second
  moveMotors(80, 80);
  delay(1000);
  
  // stop and wait a beat
  moveMotors(90,90);
  delay(500); 

  // turn right roughly 90 degrees
  moveMotors(80,100);
  delay(1000);
  
  // stop and wait a beat
  moveMotors(90,90);
  delay(500); 
}

void moveMotors(int speedL, int speedR) {
  motorL.write(speedL);
  motorR.write(180 - speedR);
}

int getDistance() {

  long duration;
  digitalWrite(trigPin, LOW);
  delayMicroseconds(2);
  digitalWrite(trigPin, HIGH);
  delayMicroseconds(10);
  digitalWrite(trigPin, LOW);
  duration = pulseIn(echoPin, HIGH);
  return (duration / 2) / 29.1;
}
